import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["className", "value", "selection", "extensions", "onChange", "theme", "height", "minHeight", "maxHeight", "width", "minWidth", "maxWidth"];
import React, { useEffect, useRef, useImperativeHandle } from "react";
import { useCodeMirror } from './useCodeMirror';
import { jsx as _jsx } from "react/jsx-runtime";
export * from './useCodeMirror';
export * from "@codemirror/view";
export * from "@codemirror/basic-setup";
export * from "@codemirror/state";
export default /*#__PURE__*/React.forwardRef(function (props, ref) {
  var className = props.className,
      value = props.value,
      selection = props.selection,
      _props$extensions = props.extensions,
      extensions = _props$extensions === void 0 ? [] : _props$extensions,
      onChange = props.onChange,
      theme = props.theme,
      height = props.height,
      minHeight = props.minHeight,
      maxHeight = props.maxHeight,
      width = props.width,
      minWidth = props.minWidth,
      maxWidth = props.maxWidth,
      other = _objectWithoutPropertiesLoose(props, _excluded);

  var editor = useRef(null);

  var _useCodeMirror = useCodeMirror({
    container: editor.current,
    value: value,
    theme: theme,
    height: height,
    minHeight: minHeight,
    maxHeight: maxHeight,
    width: width,
    minWidth: minWidth,
    maxWidth: maxWidth,
    selection: selection,
    onChange: onChange,
    extensions: extensions
  }),
      state = _useCodeMirror.state,
      view = _useCodeMirror.view,
      container = _useCodeMirror.container,
      setContainer = _useCodeMirror.setContainer;

  useImperativeHandle(ref, function () {
    return {
      editor: container,
      state: state,
      view: view
    };
  });
  useEffect(function () {
    setContainer(editor.current);
    return function () {
      if (view) {
        view.destroy();
      }
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  return /*#__PURE__*/_jsx("div", _extends({
    ref: editor,
    className: "cm-theme-" + theme + " " + (className || '')
  }, other));
});
//# sourceMappingURL=index.js.map